/*
 * Main.cpp
 *
 *  Created on: 12/giu/2010
 *      Author: fisch
 */

#define CV_NO_BACKWARD_COMPATIBILITY

#include "cv.h"
#include "highgui.h"

#include <iostream>
#include <cstdio>

#include "FaceDetector.h"

using namespace std;
using namespace cv;

String frontalCascadeName =
"/usr/local/share/opencv/haarcascades/haarcascade_frontalface_alt2.xml";
String profileCascadeName =
"/usr/local/share/opencv/haarcascades/haarcascade_profileface.xml";
String rEyeCascadeName =
"/usr/local/share/opencv/haarcascades/haarcascade_mcs_righteye.xml";
String lEyeCascadeName =
"/usr/local/share/opencv/haarcascades/haarcascade_mcs_lefteye.xml";
String mouthCascadeName =
"/usr/local/share/opencv/haarcascades/haarcascade_mcs_mouth.xml";

int main( int argc, char** argv )
{
	Mat currentFrame;
	FaceDetector detector;
    double t = 0;

    VideoCapture camera( CV_CAP_ANY );
    if( !camera.isOpened() )
    {
    	cout<< "Could not initialize capturing..." <<endl;
    	exit(-1);
    }

    detector = FaceDetector( frontalCascadeName,
							 profileCascadeName,
							 rEyeCascadeName,
							 lEyeCascadeName,
							 mouthCascadeName );

    cvNamedWindow( "result", 1 );

    for(;;)
    {
    	camera >> currentFrame;
    	flip( currentFrame, currentFrame, 1 );
    	imshow( "result", currentFrame);

    	if( waitKey( 2 ) >= 0 )
    		break;
    }

    for(;;)
    {
		t = (double)cvGetTickCount();
		camera >> currentFrame;
		flip( currentFrame, currentFrame, 1 );

		detector.faceDetect( currentFrame.data, 0, 0 );

		t = (double)cvGetTickCount() - t;
		//printf( "update time = %g ms\n", t/((double)cvGetTickFrequency()*1000.) );

		if( waitKey( 2 ) >= 0 )
			goto _cleanup_;
    }

    waitKey(0);
_cleanup_:

    cvDestroyWindow("result");

    return 0;
}
